/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_RALIMENT                                                 */
/* Tabela : RALIMENT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 27/06/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_RALIMENT'and
             type = 'TR'                 and
             u.uid = o.uid               and
             u.name = USER)
   DROP TRIGGER DTULTATU_RALIMENT
GO

CREATE TRIGGER DTULTATU_RALIMENT
ON RALIMENT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'RALIMENT', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';' +
                                                            'CDCLIENTE=' + CDCLIENTE + ';' +
                                                            'CDCONSUMIDOR=' + CDCONSUMIDOR + ';' +
                                                            'CDFAMILISALD='+ CDFAMILISALD + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);
   END
   ELSE BEGIN
      UPDATE RALIMENT
      SET DTULTATURALIM = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(RALIMENT.CDFILIAL,0)    = ISNULL(INSERTED.CDFILIAL,0))AND
            (ISNULL(RALIMENT.CDCLIENTE,0)   = ISNULL(INSERTED.CDCLIENTE,0))AND
            (ISNULL(RALIMENT.CDCONSUMIDOR,0)= ISNULL(INSERTED.CDCONSUMIDOR,0))AND
            (ISNULL(RALIMENT.CDFAMILISALD,0)= ISNULL(INSERTED.CDFAMILISALD,0));
   END;
END;
GO

UPDATE RALIMENT SET DTULTATURALIM = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATURALIM IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATURALIM' and
            type = 'D')
   ALTER TABLE RALIMENT DROP CONSTRAINT DEFAULT_DTULTATURALIM
GO

ALTER TABLE RALIMENT ADD CONSTRAINT DEFAULT_DTULTATURALIM
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATURALIM
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_RALIMENT','4.11.194';
GO

